/*!
* TableSorter 2.4.7 - Client-side table sorting with ease!
* Minified using UglifyJS (http://jscompress.com/)
* Copyright (c) 2007 Christian Bach
*/
!function($){"use strict";$.extend({tablesorter:new function(){function log(e){if(typeof console!=="undefined"&&typeof console.log!=="undefined"){console.log(e)}else{alert(e)}}function benchmark(e,t){log(e+" ("+((new Date).getTime()-t.getTime())+"ms)")}function getElementText(e,t,n){if(!t){return""}var r=e.config,i=r.textExtraction,s="";if(i==="simple"){if(r.supportsTextContent){s=t.textContent}else{s=$(t).text()}}else{if(typeof i==="function"){s=i(t,e,n)}else if(typeof i==="object"&&i.hasOwnProperty(n)){s=i[n](t,e,n)}else{s=r.supportsTextContent?t.textContent:$(t).text()}}return $.trim(s)}function detectParserForColumn(e,t,n,r){var i,s=ts.parsers.length,o=false,u="",a=true;while(u===""&&a){n++;if(t[n]){o=t[n].cells[r];u=getElementText(e,o,r);if(e.config.debug){log("Checking if value was empty on row "+n+", column: "+r+": "+u)}}else{a=false}}for(i=1;i<s;i++){if(ts.parsers[i].is(u,e,o)){return ts.parsers[i]}}return ts.parsers[0]}function buildParserCache(e){var t=e.config,n=$(e.tBodies).filter(":not(."+t.cssInfoBlock+")"),r,i,s,o,u,a,f,l="";if(n.length===0){return}r=n[0].rows;if(r[0]){i=[];s=r[0].cells.length;for(o=0;o<s;o++){u=t.$headers.filter(":not([colspan])");u=u.add(t.$headers.filter('[colspan="1"]')).filter('[data-column="'+o+'"]:last');a=t.headers[o];f=ts.getParserById(ts.getData(u,a,"sorter"));t.empties[o]=ts.getData(u,a,"empty")||t.emptyTo||(t.emptyToBottom?"bottom":"top");t.strings[o]=ts.getData(u,a,"string")||t.stringTo||"max";if(!f){f=detectParserForColumn(e,r,-1,o)}if(t.debug){l+="column:"+o+"; parser:"+f.id+"; string:"+t.strings[o]+"; empty: "+t.empties[o]+"\n"}i.push(f)}}if(t.debug){log(l)}return i}function buildCache(e){var t=e.tBodies,n=e.config,r,i,s=n.parsers,o,u,a,f,l,c,h;n.cache={};if(n.debug){h=new Date}if(n.showProcessing){ts.isProcessing(e,true)}for(f=0;f<t.length;f++){n.cache[f]={row:[],normalized:[]};if(!$(t[f]).hasClass(n.cssInfoBlock)){r=t[f]&&t[f].rows.length||0;i=t[f].rows[0]&&t[f].rows[0].cells.length||0;for(u=0;u<r;++u){l=$(t[f].rows[u]);c=[];if(l.hasClass(n.cssChildRow)){n.cache[f].row[n.cache[f].row.length-1]=n.cache[f].row[n.cache[f].row.length-1].add(l);continue}n.cache[f].row.push(l);for(a=0;a<i;++a){o=getElementText(e,l[0].cells[a],a);c.push(s[a].format(o,e,l[0].cells[a],a))}c.push(n.cache[f].normalized.length);n.cache[f].normalized.push(c)}}}if(n.showProcessing){ts.isProcessing(e)}if(n.debug){benchmark("Building cache for "+r+" rows",h)}}function appendToTable(e,t){var n=e.config,r=e.tBodies,i=[],s=n.cache,o,u,a,f,l,c,h,p,d,v,m,g;if(n.debug){g=new Date}for(d=0;d<r.length;d++){l=$(r[d]);if(!l.hasClass(n.cssInfoBlock)){c=ts.processTbody(e,l,true);o=s[d].row;u=s[d].normalized;a=u.length;f=a?u[0].length-1:0;for(h=0;h<a;h++){m=u[h][f];i.push(o[m]);if(!n.appender||!n.removeRows){v=o[m].length;for(p=0;p<v;p++){c.append(o[m][p])}}}ts.processTbody(e,c,false)}}if(n.appender){n.appender(e,i)}if(n.debug){benchmark("Rebuilt table",g)}if(!t){ts.applyWidget(e)}$(e).trigger("sortEnd",e)}function computeThIndexes(e){var t=[],n={},r=$(e).find("thead:eq(0) tr, tfoot tr"),i,s,o,u,a,f,l,c,h,p,d,v;for(i=0;i<r.length;i++){f=r[i].cells;for(s=0;s<f.length;s++){a=f[s];l=a.parentNode.rowIndex;c=l+"-"+a.cellIndex;h=a.rowSpan||1;p=a.colSpan||1;if(typeof t[l]==="undefined"){t[l]=[]}for(o=0;o<t[l].length+1;o++){if(typeof t[l][o]==="undefined"){d=o;break}}n[c]=d;$(a).attr({"data-column":d});for(o=l;o<l+h;o++){if(typeof t[o]==="undefined"){t[o]=[]}v=t[o];for(u=d;u<d+p;u++){v[u]="x"}}}}return n}function formatSortingOrder(e){return/^d/i.test(e)||e===1}function buildHeaders(e){var t=computeThIndexes(e),n,r,i,s,o,u,a=e.config;a.headerList=[];if(a.debug){o=new Date}u=$(e).find(a.selectorHeaders).each(function(e){r=$(this);n=a.headers[e];i=a.cssIcon?'<i class="'+a.cssIcon+'"></i>':"";this.innerHTML='<div class="tablesorter-header-inner">'+this.innerHTML+i+"</div>";if(a.onRenderHeader){a.onRenderHeader.apply(r,[e])}this.column=t[this.parentNode.rowIndex+"-"+this.cellIndex];this.order=formatSortingOrder(ts.getData(r,n,"sortInitialOrder")||a.sortInitialOrder)?[1,0,2]:[0,1,2];this.count=-1;if(ts.getData(r,n,"sorter")==="false"){this.sortDisabled=true;r.addClass("sorter-false")}else{r.removeClass("sorter-false")}this.lockedOrder=false;s=ts.getData(r,n,"lockedOrder")||false;if(typeof s!=="undefined"&&s!==false){this.order=this.lockedOrder=formatSortingOrder(s)?[1,1,1]:[0,0,0]}r.addClass((this.sortDisabled?"sorter-false ":" ")+a.cssHeader);a.headerList[e]=this;r.parent().addClass(a.cssHeaderRow)});if(e.config.debug){benchmark("Built headers:",o);log(u)}return u}function setHeadersCss(e){var t,n,r,i,s=e.config,o=s.sortList,u=[s.cssDesc,s.cssAsc],a=$(e).find("tfoot tr").children().removeClass(u.join(" "));s.$headers.removeClass(u.join(" "));i=o.length;for(n=0;n<i;n++){if(o[n][1]!==2){t=s.$headers.not(".sorter-false").filter('[data-column="'+o[n][0]+'"]'+(i===1?":last":""));if(t.length){for(r=0;r<t.length;r++){if(!t[r].sortDisabled){t.eq(r).addClass(u[o[n][1]]);if(a.length){a.filter('[data-column="'+o[n][0]+'"]').eq(r).addClass(u[o[n][1]])}}}}}}}function fixColumnWidth(e){if(e.config.widthFixed&&$(e).find("colgroup").length===0){var t=$("<colgroup>"),n=$(e).width();$("tr:first td",e.tBodies[0]).each(function(){t.append($("<col>").css("width",parseInt($(this).width()/n*1e3,10)/10+"%"))});$(e).prepend(t)}}function updateHeaderSortCount(e,t){var n,r,i=e.config,s=i.headerList.length,o=t||i.sortList;i.sortList=[];$.each(o,function(e,t){n=[parseInt(t[0],10),parseInt(t[1],10)];r=i.headerList[n[0]];if(r){i.sortList.push(n);r.count=n[1]%(i.sortReset?3:2)}})}function getCachedSortType(e,t){return e&&e[t]?e[t].type||"":""}function multisort(table){var dynamicExp,sortWrapper,col,mx=0,dir=0,tc=table.config,sortList=tc.sortList,l=sortList.length,bl=table.tBodies.length,sortTime,i,j,k,c,cache,lc,s,e,order,orgOrderCol;if(tc.debug){sortTime=new Date}for(k=0;k<bl;k++){dynamicExp="sortWrapper = function(a,b) {";cache=tc.cache[k];lc=cache.normalized.length;for(i=0;i<l;i++){c=sortList[i][0];order=sortList[i][1];s=/n/i.test(getCachedSortType(tc.parsers,c))?"Numeric":"Text";s+=order===0?"":"Desc";e="e"+i;if(/Numeric/.test(s)&&tc.strings[c]){for(j=0;j<lc;j++){col=Math.abs(parseFloat(cache.normalized[j][c]));mx=Math.max(mx,isNaN(col)?0:col)}if(typeof tc.string[tc.strings[c]]==="boolean"){dir=(order===0?1:-1)*(tc.string[tc.strings[c]]?-1:1)}else{dir=tc.strings[c]?tc.string[tc.strings[c]]||0:0}}dynamicExp+="var "+e+" = $.tablesorter.sort"+s+"(table,a["+c+"],b["+c+"],"+c+","+mx+","+dir+"); ";dynamicExp+="if ("+e+") { return "+e+"; } ";dynamicExp+="else { "}orgOrderCol=cache.normalized&&cache.normalized[0]?cache.normalized[0].length-1:0;dynamicExp+="return a["+orgOrderCol+"]-b["+orgOrderCol+"];";for(i=0;i<l;i++){dynamicExp+="}; "}dynamicExp+="return 0; ";dynamicExp+="}; ";cache.normalized.sort(eval(dynamicExp))}if(tc.debug){benchmark("Sorting on "+sortList.toString()+" and dir "+order+" time",sortTime)}}function resortComplete(e,t){e.trigger("updateComplete");if(typeof t==="function"){t(e[0])}}function checkResort(e,t,n){if(t!==false){e.trigger("sorton",[e[0].config.sortList,function(){resortComplete(e,n)}])}else{resortComplete(e,n)}}var ts=this;ts.version="2.4.7";ts.parsers=[];ts.widgets=[];ts.defaults={theme:"default",widthFixed:false,showProcessing:false,cancelSelection:true,dateFormat:"mmddyyyy",sortMultiSortKey:"shiftKey",usNumberFormat:true,delayInit:false,headers:{},ignoreCase:true,sortForce:null,sortList:[],sortAppend:null,sortInitialOrder:"asc",sortLocaleCompare:false,sortReset:false,sortRestart:false,emptyTo:"bottom",stringTo:"max",textExtraction:"simple",textSorter:null,widgets:[],widgetOptions:{zebra:["even","odd"]},initWidgets:true,initialized:null,onRenderHeader:null,tableClass:"tablesorter",cssAsc:"tablesorter-headerSortUp",cssChildRow:"tablesorter-childRow",cssDesc:"tablesorter-headerSortDown",cssHeader:"tablesorter-header",cssHeaderRow:"tablesorter-headerRow",cssIcon:"tablesorter-icon",cssInfoBlock:"tablesorter-infoOnly",cssProcessing:"tablesorter-processing",selectorHeaders:"> thead th, > thead td",selectorSort:"th, td",selectorRemove:".remove-me",debug:false,headerList:[],empties:{},strings:{},parsers:[]};ts.benchmark=benchmark;ts.construct=function(e){return this.each(function(){if(!this.tHead||this.tBodies.length===0||this.hasInitialized===true){return}var t,n=$(this),r,i,s,o="",u,a,f,l,c=$.metadata;this.hasInitialized=false;this.config={};r=$.extend(true,this.config,ts.defaults,e);$.data(this,"tablesorter",r);if(r.debug){$.data(this,"startoveralltimer",new Date)}r.supportsTextContent=$("<span>x</span>")[0].textContent==="x";r.supportsDataObject=parseFloat($.fn.jquery)>=1.4;r.string={max:1,min:-1,"max+":1,"max-":-1,zero:0,none:0,"null":0,top:true,bottom:false};if(!/tablesorter\-/.test(n.attr("class"))){o=r.theme!==""?" tablesorter-"+r.theme:""}n.addClass(r.tableClass+o);r.$headers=buildHeaders(this);r.parsers=buildParserCache(this);if(!r.delayInit){buildCache(this)}r.$headers.find("*").andSelf().filter(r.selectorSort).unbind("mousedown.tablesorter mouseup.tablesorter").bind("mousedown.tablesorter mouseup.tablesorter",function(e,t){var c=this.tagName.match("TH|TD")?$(this):$(this).parents("th, td").filter(":last"),h=c[0];if((e.which||e.button)!==1){return false}if(e.type==="mousedown"){l=(new Date).getTime();return e.target.tagName==="INPUT"?"":!r.cancelSelection}if(t!==true&&(new Date).getTime()-l>250){return false}if(r.delayInit&&!r.cache){buildCache(n[0])}if(!h.sortDisabled){n.trigger("sortStart",n[0]);o=!e[r.sortMultiSortKey];h.count=(h.count+1)%(r.sortReset?3:2);if(r.sortRestart){i=h;r.$headers.each(function(){if(this!==i&&(o||!$(this).is("."+r.cssDesc+",."+r.cssAsc))){this.count=-1}})}i=h.column;if(o){r.sortList=[];if(r.sortForce!==null){u=r.sortForce;for(s=0;s<u.length;s++){if(u[s][0]!==i){r.sortList.push(u[s])}}}f=h.order[h.count];if(f<2){r.sortList.push([i,f]);if(h.colSpan>1){for(s=1;s<h.colSpan;s++){r.sortList.push([i+s,f])}}}}else{if(r.sortAppend&&r.sortList.length>1){if(ts.isValueInArray(r.sortAppend[0][0],r.sortList)){r.sortList.pop()}}if(ts.isValueInArray(i,r.sortList)){for(s=0;s<r.sortList.length;s++){a=r.sortList[s];f=r.headerList[a[0]];if(a[0]===i){a[1]=f.order[f.count];if(a[1]===2){r.sortList.splice(s,1);f.count=-1}}}}else{f=h.order[h.count];if(f<2){r.sortList.push([i,f]);if(h.colSpan>1){for(s=1;s<h.colSpan;s++){r.sortList.push([i+s,f])}}}}}if(r.sortAppend!==null){u=r.sortAppend;for(s=0;s<u.length;s++){if(u[s][0]!==i){r.sortList.push(u[s])}}}n.trigger("sortBegin",n[0]);setTimeout(function(){setHeadersCss(n[0]);multisort(n[0]);appendToTable(n[0])},1)}});if(r.cancelSelection){r.$headers.each(function(){this.onselectstart=function(){return false}})}n.unbind("sortReset update updateCell addRows sorton appendCache applyWidgetId applyWidgets refreshWidgets destroy mouseup mouseleave").bind("sortReset",function(){r.sortList=[];setHeadersCss(this);multisort(this);appendToTable(this)}).bind("update",function(e,t,i){$(r.selectorRemove,this).remove();r.parsers=buildParserCache(this);buildCache(this);checkResort(n,t,i)}).bind("updateCell",function(e,t,i,s){var o,u,a,f=this,l=$(this).find("tbody"),c=l.index($(t).parents("tbody").filter(":last")),h=$(t).parents("tr").filter(":last");if(l.length&&c>=0){u=l.eq(c).find("tr").index(h);a=t.cellIndex;o=f.config.cache[c].normalized[u].length-1;f.config.cache[c].row[f.config.cache[c].normalized[u][o]]=h;f.config.cache[c].normalized[u][a]=r.parsers[a].format(getElementText(f,t,a),f,t,a);checkResort(n,i,s)}}).bind("addRows",function(e,t,i,o){var u,a=t.filter("tr").length,f=[],l=t[0].cells.length,c=this,h=$(this).find("tbody").index(t.closest("tbody"));for(u=0;u<a;u++){for(s=0;s<l;s++){f[s]=r.parsers[s].format(getElementText(c,t[u].cells[s],s),c,t[u].cells[s],s)}f.push(r.cache[h].row.length);r.cache[h].row.push([t[u]]);r.cache[h].normalized.push(f);f=[]}checkResort(n,i,o)}).bind("sorton",function(e,t,n,r){$(this).trigger("sortStart",this);updateHeaderSortCount(this,t);setHeadersCss(this);multisort(this);appendToTable(this,r);if(typeof n==="function"){n(this)}}).bind("appendCache",function(e,t,n){appendToTable(this,n);if(typeof t==="function"){t(this)}}).bind("applyWidgetId",function(e,t){ts.getWidgetById(t).format(this,r,r.widgetOptions)}).bind("applyWidgets",function(e,t){ts.applyWidget(this,t)}).bind("refreshWidgets",function(e,t,n){ts.refreshWidgets(this,t,n)}).bind("destroy",function(e,t,n){ts.destroy(this,t,n)});if(r.supportsDataObject&&typeof n.data().sortlist!=="undefined"){r.sortList=n.data().sortlist}else if(c&&n.metadata()&&n.metadata().sortlist){r.sortList=n.metadata().sortlist}ts.applyWidget(this,true);if(r.sortList.length>0){n.trigger("sorton",[r.sortList,{},!r.initWidgets])}else if(r.initWidgets){ts.applyWidget(this)}fixColumnWidth(this);if(r.showProcessing){n.unbind("sortBegin sortEnd").bind("sortBegin sortEnd",function(e){ts.isProcessing(n[0],e.type==="sortBegin")})}this.hasInitialized=true;if(r.debug){ts.benchmark("Overall initialization time",$.data(this,"startoveralltimer"))}n.trigger("tablesorter-initialized",this);if(typeof r.initialized==="function"){r.initialized(this)}})};ts.isProcessing=function(e,t,n){var r=e.config,i=n||$(e).find("."+r.cssHeader);if(t){if(r.sortList.length>0){i=i.filter(function(){return this.sortDisabled?false:ts.isValueInArray(parseFloat($(this).attr("data-column")),r.sortList)})}i.addClass(r.cssProcessing)}else{i.removeClass(r.cssProcessing)}};ts.processTbody=function(e,t,n){var r,i;if(n){t.before('<span class="tablesorter-savemyplace"/>');i=$.fn.detach?t.detach():t.remove();return i}i=$(e).find("span.tablesorter-savemyplace");t.insertAfter(i);i.remove()};ts.clearTableBody=function(e){$(e.tBodies).filter(":not(."+e.config.cssInfoBlock+")").empty()};ts.destroy=function(e,t,n){var r=$(e),i=e.config,s=r.find("thead:first");e.hasInitialized=false;s.find("tr:not(."+i.cssHeaderRow+")").remove();s.find(".tablesorter-resizer").remove();ts.refreshWidgets(e,true,true);r.removeData("tablesorter").unbind("sortReset update updateCell addRows sorton appendCache applyWidgetId applyWidgets refreshWidgets destroy mouseup mouseleave").find("."+i.cssHeader).unbind("click mousedown mousemove mouseup").removeClass(i.cssHeader+" "+i.cssAsc+" "+i.cssDesc).find(".tablesorter-header-inner").each(function(){if(i.cssIcon!==""){$(this).find("."+i.cssIcon).remove()}$(this).replaceWith($(this).contents())});if(t!==false){r.removeClass(i.tableClass)}if(typeof n==="function"){n(e)}};ts.regex=[/(^-?[0-9]+(\.?[0-9]*)[df]?e?[0-9]?$|^0x[0-9a-f]+$|[0-9]+)/gi,/(^([\w ]+,?[\w ]+)?[\w ]+,?[\w ]+\d+:\d+(:\d+)?[\w ]?|^\d{1,4}[\/\-]\d{1,4}[\/\-]\d{1,4}|^\w+, \w+ \d+, \d{4})/,/^0x[0-9a-f]+$/i];ts.sortText=function(e,t,n,r){if(t===n){return 0}var i=e.config,s=i.string[i.empties[r]||i.emptyTo],o=ts.regex,u,a,f,l,c,h,p,d;if(t===""&&s!==0){return typeof s==="boolean"?s?-1:1:-s||-1}if(n===""&&s!==0){return typeof s==="boolean"?s?1:-1:s||1}if(typeof i.textSorter==="function"){return i.textSorter(t,n,e,r)}u=t.replace(o[0],"\\0$1\\0").replace(/\\0$/,"").replace(/^\\0/,"").split("\\0");f=n.replace(o[0],"\\0$1\\0").replace(/\\0$/,"").replace(/^\\0/,"").split("\\0");a=parseInt(t.match(o[2]),16)||u.length!==1&&t.match(o[1])&&Date.parse(t);l=parseInt(n.match(o[2]),16)||a&&n.match(o[1])&&Date.parse(n)||null;if(l){if(a<l){return-1}if(a>l){return 1}}d=Math.max(u.length,f.length);for(p=0;p<d;p++){c=isNaN(u[p])?u[p]||0:parseFloat(u[p])||0;h=isNaN(f[p])?f[p]||0:parseFloat(f[p])||0;if(isNaN(c)!==isNaN(h)){return isNaN(c)?1:-1}if(typeof c!==typeof h){c+="";h+=""}if(c<h){return-1}if(c>h){return 1}}return 0};ts.sortTextDesc=function(e,t,n,r){if(t===n){return 0}var i=e.config,s=i.string[i.empties[r]||i.emptyTo];if(t===""&&s!==0){return typeof s==="boolean"?s?-1:1:s||1}if(n===""&&s!==0){return typeof s==="boolean"?s?1:-1:-s||-1}if(typeof i.textSorter==="function"){return i.textSorter(n,t,e,r)}return ts.sortText(e,n,t)};ts.getTextValue=function(e,t,n){if(t){var r,i=e.length,s=t+n;for(r=0;r<i;r++){s+=e.charCodeAt(r)}return n*s}return 0};ts.sortNumeric=function(e,t,n,r,i,s){if(t===n){return 0}var o=e.config,u=o.string[o.empties[r]||o.emptyTo];if(t===""&&u!==0){return typeof u==="boolean"?u?-1:1:-u||-1}if(n===""&&u!==0){return typeof u==="boolean"?u?1:-1:u||1}if(isNaN(t)){t=ts.getTextValue(t,i,s)}if(isNaN(n)){n=ts.getTextValue(n,i,s)}return t-n};ts.sortNumericDesc=function(e,t,n,r,i,s){if(t===n){return 0}var o=e.config,u=o.string[o.empties[r]||o.emptyTo];if(t===""&&u!==0){return typeof u==="boolean"?u?-1:1:u||1}if(n===""&&u!==0){return typeof u==="boolean"?u?1:-1:-u||-1}if(isNaN(t)){t=ts.getTextValue(t,i,s)}if(isNaN(n)){n=ts.getTextValue(n,i,s)}return n-t};ts..characterEquivalents={a:"\u00e1\u00e0\u00e2\u00e3\u00e4",A:"\u00c1\u00c0\u00c2\u00c3\u00c4",c:"\u00e7",C:"\u00c7",e:"\u00e9\u00e8\u00ea\u00eb",E:"\u00c9\u00c8\u00ca\u00cb",i:"\u00ed\u00ec\u0130\u00ee\u00ef",I:"\u00cd\u00cc\u0130\u00ce\u00cf",o:"\u00f3\u00f2\u00f4\u00f5\u00f6",O:"\u00d3\u00d2\u00d4\u00d5\u00d6",S:"\u00df",u:"\u00fa\u00f9\u00fb\u00fc",U:"\u00da\u00d9\u00db\u00dc"};ts.replaceAccents=function(e){var t,n="[",r=ts.characterEquivalents;if(!ts.characterRegex){ts.characterRegexArray={};for(t in r){if(typeof t==="string"){n+=r[t];ts.characterRegexArray[t]=new RegExp("["+r[t]+"]","g")}}ts.characterRegex=new RegExp(n+"]")}if(ts.characterRegex.test(e)){for(t in r){if(typeof t==="string"){e=e.replace(ts.characterRegexArray[t],t)}}}return e};ts.isValueInArray=function(e,t){var n,r=t.length;for(n=0;n<r;n++){if(t[n][0]===e){return true}}return false};ts.addParser=function(e){var t,n=ts.parsers.length,r=true;for(t=0;t<n;t++){if(ts.parsers[t].id.toLowerCase()===e.id.toLowerCase()){r=false}}if(r){ts.parsers.push(e)}};ts.getParserById=function(e){var t,n=ts.parsers.length;for(t=0;t<n;t++){if(ts.parsers[t].id.toLowerCase()===e.toString().toLowerCase()){return ts.parsers[t]}}return false};ts.addWidget=function(e){ts.widgets.push(e)};ts.getWidgetById=function(e){var t,n,r=ts.widgets.length;for(t=0;t<r;t++){n=ts.widgets[t];if(n&&n.hasOwnProperty("id")&&n.id.toLowerCase()===e.toLowerCase()){return n}}};ts.applyWidget=function(e,t){var n=e.config,r=n.widgetOptions,i=n.widgets.sort().reverse(),s,o,u,a=i.length;o=$.inArray("zebra",n.widgets);if(o>=0){n.widgets.splice(o,1);n.widgets.push("zebra")}if(n.debug){s=new Date}for(o=0;o<a;o++){u=ts.getWidgetById(i[o]);if(u){if(t===true&&u.hasOwnProperty("init")){u.init(e,u,n,r)}else if(!t&&u.hasOwnProperty("format")){u.format(e,n,r)}}}if(n.debug){benchmark("Completed "+(t===true?"initializing":"applying")+" widgets",s)}};ts.refreshWidgets=function(e,t,n){var r,i=e.config,s=i.widgets,o=ts.widgets,u=o.length;for(r=0;r<u;r++){if(o[r]&&o[r].id&&(t||$.inArray(o[r].id,s)<0)){if(i.debug){log("removing "+o[r].id)}if(o[r].hasOwnProperty("remove")){o[r].remove(e,i,i.widgetOptions)}}}if(n!==true){ts.applyWidget(e,t)}};ts.getData=function(e,t,n){var r="",i=$(e),s,o;if(!i.length){return""}s=$.metadata?i.metadata():false;o=" "+(i.attr("class")||"");if(typeof i.data(n)!=="undefined"||typeof i.data(n.toLowerCase())!=="undefined"){r+=i.data(n)||i.data(n.toLowerCase())}else if(s&&typeof s[n]!=="undefined"){r+=s[n]}else if(t&&typeof t[n]!=="undefined"){r+=t[n]}else if(o!==" "&&o.match(" "+n+"-")){r=o.match(new RegExp(" "+n+"-(\\w+)"))[1]||""}return $.trim(r)};ts.formatFloat=function(e,t){if(typeof e!=="string"||e===""){return e}if(t.config.usNumberFormat!==false){e=e.replace(/,/g,"")}else{e=e.replace(/[\s|\.]/g,"").replace(/,/g,".")}if(/^\s*\([.\d]+\)/.test(e)){e=e.replace(/^\s*\(/,"-").replace(/\)/,"")}var n=parseFloat(e);return isNaN(n)?$.trim(e):n};ts.isDigit=function(e){return isNaN(e)?/^[\-+(]?\d+[)]?$/.test(e.toString().replace(/[,.'\s]/g,"")):true}}});var ts=$.tablesorter;$.fn.extend({tablesorter:ts.construct});ts.addParser({id:"text",is:function(e,t,n){return true},format:function(e,t,n,r){var i=t.config;e=$.trim(i.ignoreCase?e.toLocaleLowerCase():e);return i.sortLocaleCompare?ts.replaceAccents(e):e},type:"text"});ts.addParser({id:"currency",is:function(e){return/^\(?[\u00a3$\u20ac\u00a4\u00a5\u00a2?.]\d+/.test(e)},format:function(e,t){return ts.formatFloat(e.replace(/[^\w,. \-()]/g,""),t)},type:"numeric"});ts.addParser({id:"ipAddress",is:function(e){return/^\d{1,3}[\.]\d{1,3}[\.]\d{1,3}[\.]\d{1,3}$/.test(e)},format:function(e,t){var n,r=e.split("."),i="",s=r.length;for(n=0;n<s;n++){i+=("00"+r[n]).slice(-3)}return ts.formatFloat(i,t)},type:"numeric"});ts.addParser({id:"url",is:function(e){return/^(https?|ftp|file):\/\//.test(e)},format:function(e){return $.trim(e.replace(/(https?|ftp|file):\/\//,""))},type:"text"});ts.addParser({id:"isoDate",is:function(e){return/^\d{4}[\/\-]\d{1,2}[\/\-]\d{1,2}$/.test(e)},format:function(e,t){return ts.formatFloat(e!==""?(new Date(e.replace(/-/g,"/"))).getTime()||"":"",t)},type:"numeric"});ts.addParser({id:"percent",is:function(e){return/\d%\)?$/.test(e)},format:function(e,t){return ts.formatFloat(e.replace(/%/g,""),t)},type:"numeric"});ts.addParser({id:"usLongDate",is:function(e){return/^[A-Z]{3,10}\.?\s+\d{1,2},?\s+(\d{4}|'?\d{2})\s+(([0-2]?\d:[0-5]\d)|([0-1]?\d:[0-5]\d\s?([AP]M)))$/i.test(e)},format:function(e,t){return ts.formatFloat((new Date(e.replace(/(\S)([AP]M)$/i,"$1 $2"))).getTime()||"",t)},type:"numeric"});ts.addParser({id:"shortDate",is:function(e){return/^(\d{2}|\d{4})[\/\-\,\.\s+]\d{2}[\/\-\.\,\s+](\d{2}|\d{4})$/.test(e)},format:function(e,t,n,r){var i=t.config,s=i.headerList[r],o=s.shortDateFormat;if(typeof o==="undefined"){o=s.shortDateFormat=ts.getData(s,i.headers[r],"dateFormat")||i.dateFormat}e=e.replace(/\s+/g," ").replace(/[\-|\.|\,]/g,"/");if(o==="mmddyyyy"){e=e.replace(/(\d{1,2})[\/\s](\d{1,2})[\/\s](\d{4})/,"$3/$1/$2")}else if(o==="ddmmyyyy"){e=e.replace(/(\d{1,2})[\/\s](\d{1,2})[\/\s](\d{4})/,"$3/$2/$1")}else if(o==="yyyymmdd"){e=e.replace(/(\d{4})[\/\s](\d{1,2})[\/\s](\d{1,2})/,"$1/$2/$3")}return ts.formatFloat((new Date(e)).getTime()||"",t)},type:"numeric"});ts.addParser({id:"time",is:function(e){return/^(([0-2]?\d:[0-5]\d)|([0-1]?\d:[0-5]\d\s?([AP]M)))$/i.test(e)},format:function(e,t){return ts.formatFloat((new Date("2000/01/01 "+e.replace(/(\S)([AP]M)$/i,"$1 $2"))).getTime()||"",t)},type:"numeric"});ts.addParser({id:"digit",is:function(e){return ts.isDigit(e)},format:function(e,t){return ts.formatFloat(e.replace(/[^\w,. \-()]/g,""),t)},type:"numeric"});ts.addParser({id:"metadata",is:function(e){return false},format:function(e,t,n){var r=t.config,i=!r.parserMetadataName?"sortValue":r.parserMetadataName;return $(n).metadata()[i]},type:"numeric"});ts.addWidget({id:"zebra",format:function(e,t,n){var r,i,s,o,u,a,f,l,c=new RegExp(t.cssChildRow,"i"),h=$(e).children("tbody:not(."+t.cssInfoBlock+")");if(t.debug){a=new Date}for(f=0;f<h.length;f++){r=$(h[f]);l=r.children("tr").length;if(l>1){o=0;i=r.children("tr:visible");i.each(function(){s=$(this);if(!c.test(this.className)){o++}u=o%2===0;s.removeClass(n.zebra[u?1:0]).addClass(n.zebra[u?0:1])})}}if(t.debug){ts.benchmark("Applying Zebra widget",a)}},remove:function(e,t,n){var r,i,s=$(e).children("tbody:not(."+t.cssInfoBlock+")"),o=(t.widgetOptions.zebra||["even","odd"]).join(" ");for(r=0;r<s.length;r++){i=$.tablesorter.processTbody(e,$(s[r]),true);i.children().removeClass(o);$.tablesorter.processTbody(e,i,false)}}})}(jQuery);
